/* DJGPPTSR, Nov 1995 Charles Sandmann (sandmann@clio.rice.edu)

   ABSOLULTELY NO WARRANTY.  May be redistributed or copied without restriction.

   An example of a DJGPP TSR.  This routine changes the video attribute of the
   character in the upper right of the screen once per tick (from protected
   mode).  The DPMI provider will be forced to stay resident after this image
   exits.  This code also shows an undocumented way to suppress the exception
   code loading to decrease the image footprint size.  Not optimal - you can
   do the same thing with a single GAS file with a much smaller image.  Left 
   as an exercise for the user.  Have fun!  */

#include <stdio.h>
#include <io.h>
#include <dpmi.h>
#include <crt0.h>
#include <sys/farptr.h>
#include <go32.h>
#include <pc.h>

int _stklen = 8192;
int _crt0_startup_flags = _CRT0_FLAG_LOCK_MEMORY;

void __crt0_load_environment_file(char *_app_name) { return; }
void __crt0_setup_arguments(void) { return; }
char **__crt0_glob_function(char *_arg) { return 0; }

/* Start undocumented way to make exception handling disappear */
void _npxsetup(void) { return; }
int __emu387_load_hook;
short __djgpp_ds_alias;
void __djgpp_exception_setup(void) { return; }
int __djgpp_set_ctrl_c(int enable) { return 0; }
/* End undocumented way to make exception handling disappear */

void int8(void)
{
  unsigned offset = ScreenPrimary+(2*79)+1;
  _farsetsel(_dos_ds);
  _farnspokeb(offset,1+_farnspeekb(offset));
}

void main(void)
 {
   __dpmi_regs regs;
   _go32_dpmi_seginfo pmint;
   
   pmint.pm_selector = _my_cs();
   pmint.pm_offset = (unsigned)&int8;
   _go32_dpmi_chain_protected_mode_interrupt_vector(8, &pmint);
   _write(2,"Installing DJGPP TSR\r\n",22);
/*   __djgpp_exception_toggle(); */	/* Only needed if exceptions linked */
   regs.x.ax = 0x3100;
   regs.x.dx = (256) / 16;		/* paragraphs */
   __dpmi_int(0x21, &regs);
 }
