This is Info file jptui.inf, produced by Makeinfo version 1.67 from the
input file jptui.txi.

   JPTUI.inf

   Copyright (C) 1996 by Jean-Pierre Delprat.


File: jptui.inf,  Node: TList Instanciation,  Next: TList Static Methods,  Prev: TList Data,  Up: TList

TList Instanciation
-------------------

`TList (PObject parent,int type,int rel_x,int rel_y,int width,int height,unsigned background,char *caption,int list_rel_x,int list_rel_y,int list_width,int list_height,boolean sorted,int allowed_item_attribute,boolean always_one_item_selected,boolean item_hot_key_enabled,boolean scrollbar,int scrollbar_x,int scrollbar_y,int scrollbar_height,boolean enabled)'
     Constructs a new TList object.  Arguments are as follows...

    `PObject parent'
          The parent object that the new TList should be attached to.

    `int type'
          Specifies the type of object that will be listed. *Note
          Object Type Definitions::.

    `int rel_x'
          The `x' position, relative to the `parent'.

    `int rel_y'
          The `y' position, relative to the `parent'.

    `int width'
          The width of the TList.

    `int height'
          The height of the TList.

    `unsigned background'
          The background attributes. *Note TWindow::.

    `char *caption'
          The caption to use. *Note TObject Instanciation::.

    `int list_rel_x'
          Specifies the `x' position of the actual list inside the
          TList's area.  (The actual list area is the TList's area
          excluding the area for scrollbars, etc.) This value is
          relative to the position of the TList.

    `int list_rel_y'
          Specifies the `y' position of the actual list inside the
          TList's area.  (The actual list area is the TList's area
          excluding the area for scrollbars, etc.) This value is
          relative to the position of the TList.

    `int list_width'
          Specifies the width of the actual list inside the TList's
          area.  (The actual list area is the TList's area excluding
          the area for scrollbars, etc.)

    `int list_height'
          Specifies the width of the actual list inside the TList's
          area.  (The actual list area is the TList's area excluding
          the area for scrollbars, etc.)

    `boolean sorted'
          If set, items will be automatically sorted.

    `int allowed_item_attribute'
          Specifies which attributes the items are allowed to have.
          This is a bit mask of each attribute you want -- you can make
          it by adding the attributes together with the '+' operator,
          or by ORing them with the '|' operator.

    `boolean always_one_item_selected'
          If set, an item in the list will always be selected
          (highlighted) whether the object has the focus or not.

    `boolean item_hot_key_enabled'
          If set, the highlight will jump to an item when it's hotkey
          is pressed.

    `boolean scrollbar'
          If set, the list will have a scrollbar, which will let the
          user find items more easily.  Of course, the user can still
          scroll through the list using the cursor keys even if there
          is no scrollbar.

    `int scrollbar_x'
          The `x' position of the scrollbar, relative to the list's `x'
          position.

    `int scrollbar_y'
          The `y' position of the scrollbar, relative to the list's `y'
          position.

    `int scrollbar_height'
          The height of the scrollbar.

    `boolean enabled'
          This indicates whether the object should be enabled when
          first constructed.

    `boolean focus_depending_aspect'
          Specifies whether the object's appearance changes when it
          gets or loses the focus.  If TRUE, the object will be redrawn
          at these times.  *Note TObject Instanciation::.

    `boolean enabled'
          Specifies whether the object should initially be enabled
          (TRUE) or disabled (FALSE).


File: jptui.inf,  Node: TList Static Methods,  Next: TList Access Methods,  Prev: TList Instanciation,  Up: TList

TList Static Methods
--------------------


File: jptui.inf,  Node: TList Access Methods,  Next: TList Callbacks,  Prev: TList Static Methods,  Up: TList

TList Access Methods
--------------------

`int m_get_nb_items ()'
     Returns the number of items in the list.

`char* m_get_item (int index)'
     Returns a pointer to the item at position `index', where the first
     item is 1, not 0 as is normal in C indices. Returns "" if there is
     not item at position `index'.

`int m_get_item_index (char *label)'
     Returns the index of the first item whose label is `label'.
     Returns 0 if no such item can be found.

`boolean m_set_selected_item_index (int index)'
     Moves the selection highlight to the item numbered `index'.
     Returns a boolean value which indicates whether or not the item
     could be selected.  The most usual reason for a FALSE return code
     is that the index is invalid.  Remember that index entries begin
     at 1 and not 0 for TLists.

`void m_select_first_possible_item ()'
     Selects the first item in the TList, as if by
     `m_set_selected_item_index(1)'.

`int m_get_selected_item_index ()'
     Returns the index of the currently selected item.  As always for
     TLists, the first item is 1, and not 0 as you might expect.

`void m_set_first_visible_item_index (int index)'
     Sets the item which will be at the top of the list when it is
     drawn (ie, the first visible item) to `index'.  This may not be
     possible if there aren't enough items after `index' to fill the
     rest of the list, however, the results will always be acceptable.

`int m_get_first_visible_item_index ()'
     Returns the first visible item (ie, the item at the top of the
     list when drawn).

`void m_set_middle_visible_item_index (int index)'
     Sets the item which will be drawn in the center of the list, in
     much the same way as `m_set_first_visible_item_index'.

`void m_set_last_visible_item_index (int index)'
     Sets the item which will be drawn in the list's last slot, in much
     the same way as `m_set_first_visible_item_index'.

`int m_get_last_visible_item_index ()'
     Returns the index of the last visible item.

`int m_get_list_height ()'
     Returns the height of the list, as displayed on-screen.


File: jptui.inf,  Node: TList Callbacks,  Next: TList Special,  Prev: TList Access Methods,  Up: TList

TList Callbacks
---------------

`void m_set_selected_item_changed_callback (void (*selected_item_changed_action)(PObject,char *),char *selected_item_changed_argument)'
     Sets `selected_item_changed_action' as the function to be invoked
     when the selected item changes.  The function will be called with
     it's first argument pointing to the object which called it (ie,
     the list whose item was changed).  The second argument will be a
     copy of whatever string was specified for
     `selected_item_changed_argument'.

`void m_set_visible_part_changed_callback (void (*visible_part_changed_action)(PObject,char *),char *visible_part_changed_argument)'
     Sets `visible_part_changed_callback' as the function to be invoked
     when the visible area is changed (ie, scrolled).  The function
     will be called with it's first argument pointing to the object
     which called it (ie, the list whose item was changed). The second
     argument will be a copy of whatever string was specified for
     `visible_part_changed_argument'.

`void m_set_nb_items_changed_callback (void (*nb_items_changed_action)(PObject,char *),char *nb_items_changed_argument)'
     Sets `nb_items_changed_action' as the function to be invoked when
     the number of items in the list changes.  The function will be
     called with it's first argument pointing to the object which
     called it (ie, the list whose item was changed). The second
     argument will be a copy of whatever string was specified for
     `nb_items_changed_argument'.

`void m_set_item_check_changed_callback (void (*item_check_changed_action)(PObject,int,char *),char *item_check_changed_argument)'
     Sets `item_check_changed_action' as the function to be invoked
     when an item is checked or unchecked.  The function will be called
     with it's first argument pointing to the object which called it
     (ie, the list whose item was changed), and the second argument
     indicating the item's index.  The third argument will be a copy of
     whatever string was specified for `item_check_changed_argument'.

`void m_set_item_dbl_click_callback (void (*item_dbl_click_action)(PObject,int,char *),char *item_dbl_click_argument)'
     Sets `item_dbl_click_action' as the function to be invoked when the
     number of items in the list changes.  The function will be called
     with it's first argument pointing to the object which called it
     (ie, the list whose item was changed), and the second argument
     indicating the item's index (ie, it's number in the list).  The
     third argument will be a copy of whatever string was specified for
     `item_dbl_click_argument'.


File: jptui.inf,  Node: TList Special,  Next: TList Notes,  Prev: TList Callbacks,  Up: TList

TList Special
-------------

`'
`void m_delete_item (int index)'
     Removes and deallocates the item `index'.

`int m_add_items (char* items)'
     Adds new items to the list, returning the number of items
     successfully added.  See the constructor method for more details.
     *Note TList Instanciation::.

`void m_clear_list ()'
     Removes and deallocates all items in the list.

`void m_check_item (int index)'
     Adds a checkmark to the item `index', if there isn't one already.

`void m_uncheck_item (int index)'
     Removes the checkmark from the item `index', if there is one
     present.

`boolean m_item_is_checked (int index)'
     Returns a boolean value indicating whether the item at position
     `index' is checked (TRUE) or unchecked (FALSE).

`void m_enable_item (int index)'
     Enables the item at `index', allowing the user to select it.

`void m_disable_item (int index)'
     Disables the item at `index', preventing the user from selecting
     it.

`boolean m_item_is_enabled (int index)'
     Returns a boolean value indicating whether the item at position
     `index' is currently enabled (TRUE) or disabled (FALSE).


File: jptui.inf,  Node: TList Notes,  Prev: TList Special,  Up: TList

TList Notes
-----------


File: jptui.inf,  Node: TListBox,  Next: TMenu,  Prev: TList,  Up: Classes

TListBox
========

* Menu:

* TListBox Description::       A general description of the class.

* TListBox Base Classes::      Classes which this class is derived from.
* TListBox Derived Classes::   Classes derived from this one.

* TListBox Enumerations::      Enumerations defined in this class.
* TListBox Data::              Publicly-accessible variables in the class.

* TListBox Instanciation::     Constructors and destructors for this class.

* TListBox Static Methods::    Static methods available.

* TListBox Access Methods::    Methods for data-access.

* TListBox Callbacks::         Ways of setting callback functions.

* TListBox Special::           Special methods for this class.

* TListBox Notes::             Miscellaneous notes about this class.


File: jptui.inf,  Node: TListBox Description,  Next: TListBox Base Classes,  Up: TListBox

TListBox Description
--------------------

     The TListBox class is designed to provide a programmer-friendly
     interface to the base TList class.  The TListBox class is easier
     to use, yet provides all of the same facilities and more via
     inherited methods. *Note TList::.


File: jptui.inf,  Node: TListBox Base Classes,  Next: TListBox Derived Classes,  Prev: TListBox Description,  Up: TListBox

TListBox Base Classes
---------------------

     *Note TList::.


File: jptui.inf,  Node: TListBox Derived Classes,  Next: TListBox Enumerations,  Prev: TListBox Base Classes,  Up: TListBox

TListBox Derived Classes
------------------------

     ???


File: jptui.inf,  Node: TListBox Enumerations,  Next: TListBox Data,  Prev: TListBox Derived Classes,  Up: TListBox

TListBox Enumerations
---------------------


File: jptui.inf,  Node: TListBox Data,  Next: TListBox Instanciation,  Prev: TListBox Enumerations,  Up: TListBox

TListBox Data
-------------


File: jptui.inf,  Node: TListBox Instanciation,  Next: TListBox Static Methods,  Prev: TListBox Data,  Up: TListBox

TListBox Instanciation
----------------------

`TListBox (PObject parent,int rel_x,int rel_y,int width,int height,'
     char *caption="",TListItem items[]=NULL,boolean sorted=FALSE,
     boolean items_can_be_checked=FALSE,boolean enabled=TRUE)

     Constructs a new TListBox.  Arguments are as follows...
    `PObject parent'
          The parent object that you want this TListBox to be attached
          to.

    `int rel_x'
          The `x' position of the listbox, relative to the `parent'
          object.

    `int rel_y'
          The `y' position of the listbox, relative to the `parent'
          object.

    `int width'
          The width of the listbox.

    `int height'
          The height of the listbox.

    `char* caption=""'
          The caption (label) to use for the listbox. *Note TObject::.

    `TListItem items[]=NULL'
          The items to initially add to the list. *Note TList
          Structures::.

    `boolean sorted=FALSE'
          Specifies whether the list items should be sorted, or left in
          the order the you add them in.

    `boolean items_can_be_checked=FALSE'
          Specifies whether the items can have checkmarks.

    `boolean enabled=TRUE'
          Specifies whether the TListBox should be enabled (ie, usable)
          when first created.


File: jptui.inf,  Node: TListBox Static Methods,  Next: TListBox Access Methods,  Prev: TListBox Instanciation,  Up: TListBox

TListBox Static Methods
-----------------------


File: jptui.inf,  Node: TListBox Access Methods,  Next: TListBox Callbacks,  Prev: TListBox Static Methods,  Up: TListBox

TListBox Access Methods
-----------------------


File: jptui.inf,  Node: TListBox Callbacks,  Next: TListBox Special,  Prev: TListBox Access Methods,  Up: TListBox

TListBox Callbacks
------------------


File: jptui.inf,  Node: TListBox Special,  Next: TListBox Notes,  Prev: TListBox Callbacks,  Up: TListBox

TListBox Special
----------------


File: jptui.inf,  Node: TListBox Notes,  Prev: TListBox Special,  Up: TListBox

TListBox Notes
--------------


File: jptui.inf,  Node: TMenu,  Next: TMenuBar,  Prev: TListBox,  Up: Classes

TMenu
=====

* Menu:

* TMenu Description::       A general description of the class.

* TMenu Base Classes::      Classes which this class is derived from.
* TMenu Derived Classes::   Classes derived from this one.

* TMenu Enumerations::      Enumerations defined in this class.
* TMenu Data::              Publicly-accessible variables in the class.

* TMenu Instanciation::     Constructors and destructors for this class.

* TMenu Static Methods::    Static methods available.

* TMenu Access Methods::    Methods for data-access.

* TMenu Callbacks::         Ways of setting callback functions.

* TMenu Special::           Special methods for this class.

* TMenu Notes::             Miscellaneous notes about this class.


File: jptui.inf,  Node: TMenu Description,  Next: TMenu Base Classes,  Up: TMenu

TMenu Description
-----------------

     This class provides the menus available on a window's menubar,
     such as the familiar `File' and `Edit' menus.  The actual menu bar
     is implemented via the `TMenuBar' class.  *Note TMenuBar::.


File: jptui.inf,  Node: TMenu Base Classes,  Next: TMenu Derived Classes,  Prev: TMenu Description,  Up: TMenu

TMenu Base Classes
------------------

     *Note TList::.


File: jptui.inf,  Node: TMenu Derived Classes,  Next: TMenu Enumerations,  Prev: TMenu Base Classes,  Up: TMenu

TMenu Derived Classes
---------------------

     ???


File: jptui.inf,  Node: TMenu Enumerations,  Next: TMenu Data,  Prev: TMenu Derived Classes,  Up: TMenu

TMenu Enumerations
------------------


File: jptui.inf,  Node: TMenu Data,  Next: TMenu Instanciation,  Prev: TMenu Enumerations,  Up: TMenu

TMenu Data
----------


File: jptui.inf,  Node: TMenu Instanciation,  Next: TMenu Static Methods,  Prev: TMenu Data,  Up: TMenu

TMenu Instanciation
-------------------

`TMenu (PMenuBar menu_bar,char *caption,TMenuItem items[]=NULL,boolean enabled=TRUE)'
     Constructs a new TMenu object.  Arguments are as follows...
    `PMenuBar menu_bar'
          A pointer the menubar which this menu should be part of.
          *Note TMenuBar::.

    `char* caption'
          The menu name.  *Note TObject Instanciation::.

    `TMenuItem items[]=NULL'
          The list of menuitems.  *Note TMenu Structures::.

    `boolean enabled=TRUE'
          If specified, and set to FALSE, then the menu will be
          disabled initially.  Otherwise, it will be enabled.


File: jptui.inf,  Node: TMenu Static Methods,  Next: TMenu Access Methods,  Prev: TMenu Instanciation,  Up: TMenu

TMenu Static Methods
--------------------


File: jptui.inf,  Node: TMenu Access Methods,  Next: TMenu Callbacks,  Prev: TMenu Static Methods,  Up: TMenu

TMenu Access Methods
--------------------

`void m_disable ()'
     Disables the menu.


File: jptui.inf,  Node: TMenu Callbacks,  Next: TMenu Special,  Prev: TMenu Access Methods,  Up: TMenu

TMenu Callbacks
---------------

`void m_set_item_clicked_callback (void (*item_clicked_action)(PObject,int,char *),char *item_clicked_argument)'
     Sets the function to be invoked when a menu item is clicked to
     `item_clicked_action'.  The function is called with the first
     argument pointing to the object involved (ie, the menu whose item
     was clicked).  The second argument is the number of the item
     selected, and the third argument is a copy of whatever string you
     supply for `item_clicked_argument'.


File: jptui.inf,  Node: TMenu Special,  Next: TMenu Notes,  Prev: TMenu Callbacks,  Up: TMenu

TMenu Special
-------------

`void m_click_item (int index)'
     Selects item number `index' within the menu, as if the user had
     clicked it with the mouse or pressed it's hotkey.

`int m_add_item (char* label, int attribute=LI_NOATTR,int short_cut=SC_NONE,char *help_message="")'
     Adds a new item to the menu, returning the item's index, or 0 if
     the item could not be created for some reason.  The arguments are
     the same as the fields for the TMenuItem structure.  *Note TMenu
     Structures::.

`int m_insert_item (int index, char* label, int attribute=LI_NOATTR,int short_cut=SC_NONE,char *help_message="")'
     Adds a new item to the menu, at the specified position `index',
     returning the item's index, or 0 if the item could not be created
     for some reason.  The arguments are the same as the fields for the
     TMenuItem structure.  *Note TMenu Structures::.

`int m_add_items (TMenuItem items[])'
     Adds the new items `items' to the menu.  Returns the number of
     items successfully added.  *Note TMenu Structures::.

`void m_delete_item (int item_index)'
     Deletes the menu item at position `item_index'.

`void m_clear_list ()'
     Deletes all menu items from the menu.


File: jptui.inf,  Node: TMenu Notes,  Prev: TMenu Special,  Up: TMenu

TMenu Notes
-----------


File: jptui.inf,  Node: TMenuBar,  Next: TObject,  Prev: TMenu,  Up: Classes

TMenuBar
========

* Menu:

* TMenuBar Description::       A general description of the class.

* TMenuBar Base Classes::      Classes which this class is derived from.
* TMenuBar Derived Classes::   Classes derived from this one.

* TMenuBar Enumerations::      Enumerations defined in this class.
* TMenuBar Data::              Publicly-accessible variables in the class.

* TMenuBar Instanciation::     Constructors and destructors for this class.

* TMenuBar Static Methods::    Static methods available.

* TMenuBar Access Methods::    Methods for data-access.

* TMenuBar Callbacks::         Ways of setting callback functions.

* TMenuBar Special::           Special methods for this class.

* TMenuBar Notes::             Miscellaneous notes about this class.


File: jptui.inf,  Node: TMenuBar Description,  Next: TMenuBar Base Classes,  Up: TMenuBar

TMenuBar Description
--------------------

     The TMenuBar class provides the main menu at the top of each
     window.  To this, you add the individual menus via the TMenu
     class. *Note TMenu::.


File: jptui.inf,  Node: TMenuBar Base Classes,  Next: TMenuBar Derived Classes,  Prev: TMenuBar Description,  Up: TMenuBar

TMenuBar Base Classes
---------------------

     *Note TObject::.


File: jptui.inf,  Node: TMenuBar Derived Classes,  Next: TMenuBar Enumerations,  Prev: TMenuBar Base Classes,  Up: TMenuBar

TMenuBar Derived Classes
------------------------

     ???


File: jptui.inf,  Node: TMenuBar Enumerations,  Next: TMenuBar Data,  Prev: TMenuBar Derived Classes,  Up: TMenuBar

TMenuBar Enumerations
---------------------


File: jptui.inf,  Node: TMenuBar Data,  Next: TMenuBar Instanciation,  Prev: TMenuBar Enumerations,  Up: TMenuBar

TMenuBar Data
-------------


File: jptui.inf,  Node: TMenuBar Instanciation,  Next: TMenuBar Static Methods,  Prev: TMenuBar Data,  Up: TMenuBar

TMenuBar Instanciation
----------------------

`TMenuBar (PWindow window)'
     Constructs a new TMenuBar object.  You should pass a pointer to
     the window that you want to attach the menu to in the `window'
     argument.


File: jptui.inf,  Node: TMenuBar Static Methods,  Next: TMenuBar Access Methods,  Prev: TMenuBar Instanciation,  Up: TMenuBar

TMenuBar Static Methods
-----------------------


File: jptui.inf,  Node: TMenuBar Access Methods,  Next: TMenuBar Callbacks,  Prev: TMenuBar Static Methods,  Up: TMenuBar

TMenuBar Access Methods
-----------------------

`void m_enable ()'
     Enables the menu bar.

`void m_disable ()'
     Disables the menu bar.


File: jptui.inf,  Node: TMenuBar Callbacks,  Next: TMenuBar Special,  Prev: TMenuBar Access Methods,  Up: TMenuBar

TMenuBar Callbacks
------------------


File: jptui.inf,  Node: TMenuBar Special,  Next: TMenuBar Notes,  Prev: TMenuBar Callbacks,  Up: TMenuBar

TMenuBar Special
----------------


File: jptui.inf,  Node: TMenuBar Notes,  Prev: TMenuBar Special,  Up: TMenuBar

TMenuBar Notes
--------------


File: jptui.inf,  Node: TObject,  Next: TPasswordEditZone,  Prev: TMenuBar,  Up: Classes

TObject
=======

* Menu:

* TObject Description::       A general description of the class.

* TObject Base Classes::      Classes which this class is derived from.
* TObject Derived Classes::   Classes derived from this one.

* TObject Enumerations::      Enumerations defined in this class.
* TObject Data::              Publicly-accessible variables in the class.

* TObject Instanciation::     Constructors and destructors for this class.

* TObject Static Methods::    Static methods available.

* TObject Access Methods::    Methods for data-access.

* TObject Callbacks::         Ways of setting callback functions.

* TObject Special::           Special methods for this class.

* TObject Notes::             Miscellaneous notes about this class.


File: jptui.inf,  Node: TObject Description,  Next: TObject Base Classes,  Up: TObject

TObject Description
-------------------

     This is the basic object class from which all other objects are
     derived.  It provides the basic features which all objects need.


File: jptui.inf,  Node: TObject Base Classes,  Next: TObject Derived Classes,  Prev: TObject Description,  Up: TObject

TObject Base Classes
--------------------

     None.


File: jptui.inf,  Node: TObject Derived Classes,  Next: TObject Enumerations,  Prev: TObject Base Classes,  Up: TObject

TObject Derived Classes
-----------------------

     ???


File: jptui.inf,  Node: TObject Enumerations,  Next: TObject Data,  Prev: TObject Derived Classes,  Up: TObject

TObject Enumerations
--------------------


File: jptui.inf,  Node: TObject Data,  Next: TObject Instanciation,  Prev: TObject Enumerations,  Up: TObject

TObject Data
------------


File: jptui.inf,  Node: TObject Instanciation,  Next: TObject Static Methods,  Prev: TObject Data,  Up: TObject

TObject Instanciation
---------------------

`TObject(PObject parent,int type,int rel_x,int rel_y,int width,int height,unsigned background,char *caption,boolean enabled,boolean focus_depending_aspect,boolean can_be_enabled,boolean simple)'
     Creates an object of this class.  Arguments are as follows...
    `PObject parent'
          The parent object which this one should be attached to.  This
          can either be a normal object, to create complex objects, or
          simply the window to which the object should be attached.

    `int type'
          A special identifier which indicates the type of object this
          is.  *Note Object Type Definitions::.

    `int rel_x'
          The object's `x' position, relative to the parent object's
          position.

    `int rel_y'
          The object's `y' position, relative to the parent object's
          position.

    `int width'
          The width of the object.

    `int height'
          The height of the object.

    `unsigned background'
          An extended character (ie, char in low byte, and VGA
          attributes in the high-byte) which specifies the character to
          use for the background.

    `char* caption'
          The caption text to use.  This text is displayed near the
          object, or within the object for certain types.  It is
          normally used to name the object, and to inform the user of
          keyboard shortcuts (by specifying a hotkey).

          `caption' has a special string_format (*Note String
          Datatypes::).

    `boolean enabled'
          Specifies whether the object is to be enabled or disabled
          (ie, non-selectable) when first created.  If you set this
          flag to TRUE during instanciation, you can change it
          dynamically though a call to `m_set_can_be_enabled' (see
          below).

    `focus_depending_aspect'
          Specifies whether the object's appearance changes when it
          gets or loses the focus.  If TRUE, the object will be redrawn
          at these times.

    `can_be_enabled'
          Specifies whether the object can be enabled, or not.  For
          example, some objects are only there for visual purposes, and
          need never be active, such as labels.

          Still others might need to be disabled at certain times, when
          they are not applicable.  In these cases, you need to set
          `can_be_enabled' to TRUE, and manage it with `m_enable()',
          `m_disable()', and `m_can_be_enabled()'.

    `simple'
          Specifies that the object will have no child objects.


File: jptui.inf,  Node: TObject Static Methods,  Next: TObject Access Methods,  Prev: TObject Instanciation,  Up: TObject

TObject Static Methods
----------------------


File: jptui.inf,  Node: TObject Access Methods,  Next: TObject Callbacks,  Prev: TObject Static Methods,  Up: TObject

TObject Access Methods
----------------------

`int m_get_number ()'
     Returns the item's index within it's parent object.  For example...
          	Object                   Number
          	--------------------------------------------------------------------
              Frame Group              1          (within the window)
          	- Button                 1          (within the Frame Group)
          	- Label                  2          (within the Frame Group)
          	Button                   2          (within the window)

`int m_get_type ()'
     Returns a special indentifier which specifies the object's type.
     *Note Object Type Definitions::.

`PObject m_get_parent ()'
     Returns a pointer to this object's parent object.

`PWindow m_get_window ()'
     Returns a pointer to the window that this object is attached to.

`int m_get_x_in_window ()'
     Returns the absolute `x' position of the object in it's window.

`int m_get_y_in_window ()'
     Returns the absolute `y' position of the object in it's window.

`int m_get_x ()'
     Returns the `x' position of the object relative to it's parent
     object.

`int m_get_y ()'
     Returns the `y' position of the object relative to it's parent
     object.

`int m_get_width ()'
     Returns the object's width.

`int m_get_height ()'
     Returns the object's height.

`void m_set_size (int width, int height)'
     Resizes the object to `width' by `height'.

`unsigned m_get_background ()'
     Returns the background character (in the low-byte), and it's
     attributes (in the high-byte).

`char* m_get_caption ()'
     Returns the object's caption.  *Note TObject Instanciation::.

`void m_set_caption (char* caption)'
     Changes the objects caption to `caption'.  `caption' has a special
     string_format (*Note String Datatypes::).

     In order to change the caption of an object, this object must
     already have a caption. So, when you declare an object without
     caption, use the string " " for the `caption' parameter if you
     want to change its caption at run-time.  *Note TObject
     Instanciation::.

`char m_get_hotkey ()'
     Returns the object's hotkey.  *Note TObject Instanciation::.

`boolean m_is_open ()'
     Returns a boolean value which indicates whether the object is
     currently open.

`boolean m_has_focus ()'
     Returns a boolean value which indicates whether the object has the
     focus (ie, whether it is the active object).

`boolean m_is_enabled ()'
     Returns a boolean value which indicates if the object is enabled
     (TRUE), or disabled (FALSE).  Disabled objects can not be used,
     and will appear to be darker, or `ghosted'.

`void m_enable ()'
     Enables the object, making it possible for the user to interact
     with it.  The object must have the `can_be_enabled' flag set for
     this to work.  *Note TObject Instanciation::.

`void m_disable ()'
     Disables the object, making it user interaction with it impossible.

`void m_set_can_be_enabled (boolean mode)'
     Changes the current state of the object's `can_be_enabled' to
     `mode'.  You can only enable the object when this flag is TRUE.
     *This function can only be used on objects which had their
     `can_be_enabled' flag set during instanciation*.

`boolean m_can_lose_focus ()'
     Returns a boolean value which indicates whether the current focus
     can be taken from this object, and given to another.  If not, then
     other objects cannot be selected.


File: jptui.inf,  Node: TObject Callbacks,  Next: TObject Special,  Prev: TObject Access Methods,  Up: TObject

TObject Callbacks
-----------------

`void m_set_focus_lost_callback (void (*focus_lost_action)(TObject *,char *), char *focus_lost_argument)'
     ) Sets the function to be called when this object loses the focus
     to `focus_lost_action'. The function will be called with it's
     first argument pointing to this object.  The second argument will
     be a copy of the string given for `focus_lost_argument'.

`void m_set_focus_taken_callback (void (*focus_taken_action)(TObject *,char *), char *focus_taken_argument)'
     Sets the function to be called when this object gets the focus to
     `focus_taken_action'. The function will be called with it's first
     argument pointing to this object.  The second argument will be a
     copy of the string given for `focus_taken_argument'.


File: jptui.inf,  Node: TObject Special,  Next: TObject Notes,  Prev: TObject Callbacks,  Up: TObject

TObject Special
---------------

`boolean m_set_focus ()'
     Sets the focus to the first element (child object) of the object,
     and activates the actual object itself.  Returns a boolean value
     which indicates success or failure.

`boolean m_set_focus_to_last_element ()'
     Sets the focus to the last element (child object).


File: jptui.inf,  Node: TObject Notes,  Prev: TObject Special,  Up: TObject

TObject Notes
-------------


File: jptui.inf,  Node: TPasswordEditZone,  Next: TPushButton,  Prev: TObject,  Up: Classes

TPasswordEditZone
=================

* Menu:

* TPasswordEditZone Description::       A general description of the class.

* TPasswordEditZone Base Classes::      Classes which this class is derived from.
* TPasswordEditZone Derived Classes::   Classes derived from this one.

* TPasswordEditZone Enumerations::      Enumerations defined in this class.
* TPasswordEditZone Data::              Publicly-accessible variables in the class.

* TPasswordEditZone Instanciation::     Constructors and destructors for this class.

* TPasswordEditZone Static Methods::    Static methods available.

* TPasswordEditZone Access Methods::    Methods for data-access.

* TPasswordEditZone Callbacks::         Ways of setting callback functions.

* TPasswordEditZone Special::           Special methods for this class.

* TPasswordEditZone Notes::             Miscellaneous notes about this class.


File: jptui.inf,  Node: TPasswordEditZone Description,  Next: TPasswordEditZone Base Classes,  Up: TPasswordEditZone

TPasswordEditZone Description
-----------------------------

     This class is the same as the TEditZone class, except that each
     character of the zone is displayed as a '*'.


File: jptui.inf,  Node: TPasswordEditZone Base Classes,  Next: TPasswordEditZone Derived Classes,  Prev: TPasswordEditZone Description,  Up: TPasswordEditZone

TPasswordEditZone Base Classes
------------------------------

     *Note TEditZone::.


File: jptui.inf,  Node: TPasswordEditZone Derived Classes,  Next: TPasswordEditZone Enumerations,  Prev: TPasswordEditZone Base Classes,  Up: TPasswordEditZone

TPasswordEditZone Derived Classes
---------------------------------


File: jptui.inf,  Node: TPasswordEditZone Enumerations,  Next: TPasswordEditZone Data,  Prev: TPasswordEditZone Derived Classes,  Up: TPasswordEditZone

TPasswordEditZone Enumerations
------------------------------


File: jptui.inf,  Node: TPasswordEditZone Data,  Next: TPasswordEditZone Instanciation,  Prev: TPasswordEditZone Enumerations,  Up: TPasswordEditZone

TPasswordEditZone Data
----------------------


File: jptui.inf,  Node: TPasswordEditZone Instanciation,  Next: TPasswordEditZone Static Methods,  Prev: TPasswordEditZone Data,  Up: TPasswordEditZone

TPasswordEditZone Instanciation
-------------------------------

`TPasswordEditZone (PObject parent,int rel_x,int rel_y,int xoffset_caption,int yoffset_caption,char *caption,int display_length,int max_length,char *string="",boolean enabled=TRUE)'
     All the arguments here are directly-related to the arguments for
     the TEditZone constructor (*Note TEditZone Instanciation::).


File: jptui.inf,  Node: TPasswordEditZone Static Methods,  Next: TPasswordEditZone Access Methods,  Prev: TPasswordEditZone Instanciation,  Up: TPasswordEditZone

TPasswordEditZone Static Methods
--------------------------------


File: jptui.inf,  Node: TPasswordEditZone Access Methods,  Next: TPasswordEditZone Callbacks,  Prev: TPasswordEditZone Static Methods,  Up: TPasswordEditZone

TPasswordEditZone Access Methods
--------------------------------


File: jptui.inf,  Node: TPasswordEditZone Callbacks,  Next: TPasswordEditZone Special,  Prev: TPasswordEditZone Access Methods,  Up: TPasswordEditZone

TPasswordEditZone Callbacks
---------------------------


File: jptui.inf,  Node: TPasswordEditZone Special,  Next: TPasswordEditZone Notes,  Prev: TPasswordEditZone Callbacks,  Up: TPasswordEditZone

TPasswordEditZone Special
-------------------------


File: jptui.inf,  Node: TPasswordEditZone Notes,  Prev: TPasswordEditZone Special,  Up: TPasswordEditZone

TPasswordEditZone Notes
-----------------------


File: jptui.inf,  Node: TPushButton,  Next: TRadioGroup,  Prev: TPasswordEditZone,  Up: Classes

TPushButton
===========

* Menu:

* TPushButton Description::       A general description of the class.

* TPushButton Base Classes::      Classes which this class is derived from.
* TPushButton Derived Classes::   Classes derived from this one.

* TPushButton Enumerations::      Enumerations defined in this class.
* TPushButton Data::              Publicly-accessible variables in the class.

* TPushButton Instanciation::     Constructors and destructors for this class.

* TPushButton Static Methods::    Static methods available.

* TPushButton Access Methods::    Methods for data-access.

* TPushButton Callbacks::         Ways of setting callback functions.

* TPushButton Special::           Special methods for this class.

* TPushButton Notes::             Miscellaneous notes about this class.


File: jptui.inf,  Node: TPushButton Description,  Next: TPushButton Base Classes,  Up: TPushButton

TPushButton Description
-----------------------

     This class provides capabilities for the standard textual buttons
     which are essential for any visual user-interface... the ones
     like, "OK", "Cancel", etc.


File: jptui.inf,  Node: TPushButton Base Classes,  Next: TPushButton Derived Classes,  Prev: TPushButton Description,  Up: TPushButton

TPushButton Base Classes
------------------------

     *Note TObject::.


File: jptui.inf,  Node: TPushButton Derived Classes,  Next: TPushButton Enumerations,  Prev: TPushButton Base Classes,  Up: TPushButton

TPushButton Derived Classes
---------------------------

     ???


File: jptui.inf,  Node: TPushButton Enumerations,  Next: TPushButton Data,  Prev: TPushButton Derived Classes,  Up: TPushButton

TPushButton Enumerations
------------------------


File: jptui.inf,  Node: TPushButton Data,  Next: TPushButton Instanciation,  Prev: TPushButton Enumerations,  Up: TPushButton

TPushButton Data
----------------


File: jptui.inf,  Node: TPushButton Instanciation,  Next: TPushButton Static Methods,  Prev: TPushButton Data,  Up: TPushButton

TPushButton Instanciation
-------------------------

`TPushButton (PObject parent,int rel_x,int rel_y,int width,char *caption,int  type=PB_NORMAL,boolean enabled=TRUE)'
     Creates a new TPushButton object.  All arguments are
     directly-related to the arguments by the same name in the TObject
     base class, except for `type'.  *Note TObject Instanciation::.
     `type' specifies the kind of pushbutton you want - *Note
     PushButton Type Definitions::.


File: jptui.inf,  Node: TPushButton Static Methods,  Next: TPushButton Access Methods,  Prev: TPushButton Instanciation,  Up: TPushButton

TPushButton Static Methods
--------------------------


File: jptui.inf,  Node: TPushButton Access Methods,  Next: TPushButton Callbacks,  Prev: TPushButton Static Methods,  Up: TPushButton

TPushButton Access Methods
--------------------------


File: jptui.inf,  Node: TPushButton Callbacks,  Next: TPushButton Special,  Prev: TPushButton Access Methods,  Up: TPushButton

TPushButton Callbacks
---------------------

`void m_set_pressed_callback (void (*pressed_action)(PObject,char *),char *pressed_argument)'
     Sets the function to be called when this pushbutton is pressed to
     `pressed_action'.  The first argument passed to the function will
     be a pointer to the object, while the second is a copy of whatever
     string is given for `pressed_argument'.


File: jptui.inf,  Node: TPushButton Special,  Next: TPushButton Notes,  Prev: TPushButton Callbacks,  Up: TPushButton

TPushButton Special
-------------------

`void m_press ()'
     Presses the object, as if the user had selected it with the mouse
     or it's hotkey.  This provides a visual-confirmation that whatever
     the user wants is being done, as well as providing you with a
     consistant way of invoking the pushbutton's callback.


File: jptui.inf,  Node: TPushButton Notes,  Prev: TPushButton Special,  Up: TPushButton

TPushButton Notes
-----------------


File: jptui.inf,  Node: TRadioGroup,  Next: TRadioButton,  Prev: TPushButton,  Up: Classes

TRadioGroup
===========

* Menu:

* TRadioGroup Description::       A general description of the class.

* TRadioGroup Base Classes::      Classes which this class is derived from.
* TRadioGroup Derived Classes::   Classes derived from this one.

* TRadioGroup Enumerations::      Enumerations defined in this class.
* TRadioGroup Data::              Publicly-accessible variables in the class.

* TRadioGroup Instanciation::     Constructors and destructors for this class.

* TRadioGroup Static Methods::    Static methods available.

* TRadioGroup Access Methods::    Methods for data-access.

* TRadioGroup Callbacks::         Ways of setting callback functions.

* TRadioGroup Special::           Special methods for this class.

* TRadioGroup Notes::             Miscellaneous notes about this class.


File: jptui.inf,  Node: TRadioGroup Description,  Next: TRadioGroup Base Classes,  Up: TRadioGroup

TRadioGroup Description
-----------------------

     This class provides the bounding area (via the TFrame class) and
     other things required for Radio buttons.


File: jptui.inf,  Node: TRadioGroup Base Classes,  Next: TRadioGroup Derived Classes,  Prev: TRadioGroup Description,  Up: TRadioGroup

TRadioGroup Base Classes
------------------------

     *Note TFrame::.


File: jptui.inf,  Node: TRadioGroup Derived Classes,  Next: TRadioGroup Enumerations,  Prev: TRadioGroup Base Classes,  Up: TRadioGroup

TRadioGroup Derived Classes
---------------------------

     ???


File: jptui.inf,  Node: TRadioGroup Enumerations,  Next: TRadioGroup Data,  Prev: TRadioGroup Derived Classes,  Up: TRadioGroup

TRadioGroup Enumerations
------------------------


File: jptui.inf,  Node: TRadioGroup Data,  Next: TRadioGroup Instanciation,  Prev: TRadioGroup Enumerations,  Up: TRadioGroup

TRadioGroup Data
----------------


File: jptui.inf,  Node: TRadioGroup Instanciation,  Next: TRadioGroup Static Methods,  Prev: TRadioGroup Data,  Up: TRadioGroup

TRadioGroup Instanciation
-------------------------

`TRadioGroup (PObject parent,int rel_x,int rel_y,int width,int height,char *caption="",boolean enabled=TRUE)'
     Creates a new TRadioGroup object.  All arguments are
     directly-related to the arguments for the TObject base class.
     *Note TObject Instanciation::.


File: jptui.inf,  Node: TRadioGroup Static Methods,  Next: TRadioGroup Access Methods,  Prev: TRadioGroup Instanciation,  Up: TRadioGroup

TRadioGroup Static Methods
--------------------------


File: jptui.inf,  Node: TRadioGroup Access Methods,  Next: TRadioGroup Callbacks,  Prev: TRadioGroup Static Methods,  Up: TRadioGroup

TRadioGroup Access Methods
--------------------------


File: jptui.inf,  Node: TRadioGroup Callbacks,  Next: TRadioGroup Special,  Prev: TRadioGroup Access Methods,  Up: TRadioGroup

TRadioGroup Callbacks
---------------------


File: jptui.inf,  Node: TRadioGroup Special,  Next: TRadioGroup Notes,  Prev: TRadioGroup Callbacks,  Up: TRadioGroup

TRadioGroup Special
-------------------


File: jptui.inf,  Node: TRadioGroup Notes,  Prev: TRadioGroup Special,  Up: TRadioGroup

TRadioGroup Notes
-----------------


File: jptui.inf,  Node: TRadioButton,  Next: TScrollBar,  Prev: TRadioGroup,  Up: Classes

TRadioButton
============

* Menu:

* TRadioButton Description::       A general description of the class.

* TRadioButton Base Classes::      Classes which this class is derived from.
* TRadioButton Derived Classes::   Classes derived from this one.

* TRadioButton Enumerations::      Enumerations defined in this class.
* TRadioButton Data::              Publicly-accessible variables in the class.

* TRadioButton Instanciation::     Constructors and destructors for this class.

* TRadioButton Static Methods::    Static methods available.

* TRadioButton Access Methods::    Methods for data-access.

* TRadioButton Callbacks::         Ways of setting callback functions.

* TRadioButton Special::           Special methods for this class.

* TRadioButton Notes::             Miscellaneous notes about this class.


File: jptui.inf,  Node: TRadioButton Description,  Next: TRadioButton Base Classes,  Up: TRadioButton

TRadioButton Description
------------------------


File: jptui.inf,  Node: TRadioButton Base Classes,  Next: TRadioButton Derived Classes,  Prev: TRadioButton Description,  Up: TRadioButton

TRadioButton Base Classes
-------------------------

     *Note TCheckBox::.


File: jptui.inf,  Node: TRadioButton Derived Classes,  Next: TRadioButton Enumerations,  Prev: TRadioButton Base Classes,  Up: TRadioButton

TRadioButton Derived Classes
----------------------------

     ???


File: jptui.inf,  Node: TRadioButton Enumerations,  Next: TRadioButton Data,  Prev: TRadioButton Derived Classes,  Up: TRadioButton

TRadioButton Enumerations
-------------------------


File: jptui.inf,  Node: TRadioButton Data,  Next: TRadioButton Instanciation,  Prev: TRadioButton Enumerations,  Up: TRadioButton

TRadioButton Data
-----------------


File: jptui.inf,  Node: TRadioButton Instanciation,  Next: TRadioButton Static Methods,  Prev: TRadioButton Data,  Up: TRadioButton

TRadioButton Instanciation
--------------------------

`TRadioButton (PRadioGroup radio_group,int rel_x,int rel_y,int width,char *caption,boolean checked=FALSE,boolean enabled=TRUE)'
     Creates a new TRadioButton object.  All arguments are
     directly-related to the arguments by the same name in the TObject
     base class. *Note TObject Instanciation::.  Just remember that the
     first argument is has been renamed to radio_group instead of
     parent to emphasise that the parent *must* be a pointer to a
     TRadioGroup object.


File: jptui.inf,  Node: TRadioButton Static Methods,  Next: TRadioButton Access Methods,  Prev: TRadioButton Instanciation,  Up: TRadioButton

TRadioButton Static Methods
---------------------------


File: jptui.inf,  Node: TRadioButton Access Methods,  Next: TRadioButton Callbacks,  Prev: TRadioButton Static Methods,  Up: TRadioButton

TRadioButton Access Methods
---------------------------


File: jptui.inf,  Node: TRadioButton Callbacks,  Next: TRadioButton Special,  Prev: TRadioButton Access Methods,  Up: TRadioButton

TRadioButton Callbacks
----------------------


File: jptui.inf,  Node: TRadioButton Special,  Next: TRadioButton Notes,  Prev: TRadioButton Callbacks,  Up: TRadioButton

TRadioButton Special
--------------------

`void m_check ()'
`void m_uncheck ()'
     *Note TCheckBox Special::.


File: jptui.inf,  Node: TRadioButton Notes,  Prev: TRadioButton Special,  Up: TRadioButton

TRadioButton Notes
------------------


File: jptui.inf,  Node: TScrollBar,  Next: TSimpleList,  Prev: TRadioButton,  Up: Classes

TScrollBar
==========

* Menu:

* TScrollBar Description::       A general description of the class.

* TScrollBar Base Classes::      Classes which this class is derived from.
* TScrollBar Derived Classes::   Classes derived from this one.

* TScrollBar Enumerations::      Enumerations defined in this class.
* TScrollBar Data::              Publicly-accessible variables in the class.

* TScrollBar Instanciation::     Constructors and destructors for this class.

* TScrollBar Static Methods::    Static methods available.

* TScrollBar Access Methods::    Methods for data-access.

* TScrollBar Callbacks::         Ways of setting callback functions.

* TScrollBar Special::           Special methods for this class.

* TScrollBar Notes::             Miscellaneous notes about this class.


File: jptui.inf,  Node: TScrollBar Description,  Next: TScrollBar Base Classes,  Up: TScrollBar

TScrollBar Description
----------------------

     This class provides scrollbars (sometimes known as sliders or
     proportional gadgets).  You can use them to allow users to select
     a portion of a larger area (such as to allow the user to scroll
     around a large text file when the window is too small for it), or
     to allow selection of values (for example, you could use it as a
     volume control too, although the TGauge class is perhaps more
     suited to that).


File: jptui.inf,  Node: TScrollBar Base Classes,  Next: TScrollBar Derived Classes,  Prev: TScrollBar Description,  Up: TScrollBar

TScrollBar Base Classes
-----------------------

     *Note TObject::.


File: jptui.inf,  Node: TScrollBar Derived Classes,  Next: TScrollBar Enumerations,  Prev: TScrollBar Base Classes,  Up: TScrollBar

TScrollBar Derived Classes
--------------------------

     ???


File: jptui.inf,  Node: TScrollBar Enumerations,  Next: TScrollBar Data,  Prev: TScrollBar Derived Classes,  Up: TScrollBar

TScrollBar Enumerations
-----------------------


File: jptui.inf,  Node: TScrollBar Data,  Next: TScrollBar Instanciation,  Prev: TScrollBar Enumerations,  Up: TScrollBar

TScrollBar Data
---------------


File: jptui.inf,  Node: TScrollBar Instanciation,  Next: TScrollBar Static Methods,  Prev: TScrollBar Data,  Up: TScrollBar

TScrollBar Instanciation
------------------------

`TScrollBar (PObject parent,TSbOrientation orientation,int rel_x,int rel_y,int length,boolean enabled=TRUE)'
     Constructs a new scrollbar.  `parent',`rel_x',`rel_y', and
     `enabled' are directly related to the same arguments in the base
     class's constructor method, so their descriptions aren't repeated
     here.  *Note TObject Instanciation::.  The other arguments are
     detailed below...

    `orientation'
          This specifies whether the scrollbar should be vertical or
          horizontal.  *Note ScrollBar Definitions::.

    `length'
          This is the length of the scrollbar (ie, the height if you
          specify a vertical scrollbar, or the width if you specify a
          horizontal scrollbar).

