/*
 * Copyright (C) 1996, jack
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

/* $Id: _ungetwc.c,v 1.2 1996/08/01 08:36:43 jack Exp $ */

#include <stdio.h>
#include <wchar.h>
#include <wcprvt.h>

wint_t
__ungetwc (wint_t wc, FILE *fp)
{
  wint_t wtmp = wc;
  size_t bytes = sizeof (wchar_t);
  int c;

  while (bytes-- > 0)
    {
      c = (int) (wtmp & 0x000000ffU);
      c = ungetc (c, fp);
      if (c == EOF)
	{
	  /* redo */
	  while (bytes++ < sizeof (wchar_t))
	    (void) fgetc (fp);
	  return WEOF;
	}
      wtmp >>= 8;
    }

  return wc;
}
